package ro.ieval.unical;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.TextView;

public class DisplayEventActivity extends Activity {
	public static final String EXTRA_EVENT = "event";
	private Event event;

	public static void displayEvent(final Context context, final Event event){
		final Intent i=new Intent(context,DisplayEventActivity.class);
		i.putExtra(DisplayEventActivity.EXTRA_EVENT, event);
		context.startActivity(i);
	}

	@Override
	protected void onCreate(final Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		event=getIntent().getParcelableExtra(EXTRA_EVENT);
		setContentView(R.layout.event_view);
		setTitle(event.title);

		final TextView startDay= (TextView) findViewById(R.id.startday);
		final TextView endDay= (TextView) findViewById(R.id.endday);
		final TextView startDate= (TextView) findViewById(R.id.startdate);
		final TextView endDate= (TextView) findViewById(R.id.enddate);
		final TextView startTime= (TextView) findViewById(R.id.starttime);
		final TextView endTime= (TextView) findViewById(R.id.endtime);
		final TextView description= (TextView) findViewById(R.id.event_view_description);

		final Date start=new Date(event.dtstart);
		final Date end=new Date(event.dtend);
		final SimpleDateFormat dateFormat = new SimpleDateFormat("MM/dd/yyyy", Locale.UK);
		final SimpleDateFormat timeFormat = new SimpleDateFormat("HH:mm:ss", Locale.UK);
		final SimpleDateFormat dayOfWeekFormat = new SimpleDateFormat("EEEEEEE", Locale.UK);

		startDay.setText(dayOfWeekFormat.format(start));
		if(!dateFormat.format(start).equals(dateFormat.format(end))) {
			endDay.setText(dayOfWeekFormat.format(end));
			endDate.setText(dateFormat.format(end));
		}
		startDate.setText(dateFormat.format(start));
		startTime.setText(timeFormat.format(start));
		endTime.setText(timeFormat.format(end));
		description.setText(event.description);
	}

	@Override
	public boolean onCreateOptionsMenu(final Menu menu) {
		final MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.event, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(final MenuItem item) {
		// Handle item selection
		switch (item. getItemId()) {
		case R.id.deleteevent:
			final DeleteEventDialog d=new DeleteEventDialog(event,this);
			d.show(getFragmentManager(), "Delete");
			return true;
		case R.id.eventlist:
			final Intent it=new Intent(this,EventListActivity.class);
			startActivity(it);
			return true;
		case R.id.edit_event:
			AddEventActivity.editEvent(DisplayEventActivity.this,event);
			return true;
		case R.id.add_alarm:

			return true;
		default:
			return true;
		}
	}
}
